  MEMBER

  include('cciworkr.inc'),once


    map
        WorkerThread(String addr)
        module('winapi')
            sleep(long),raw,pascal
        end
    end


WorkerThread        procedure(String addr)
worker  &cciWorkerClass
    code
    worker &= (addr)
    if worker &= null
        message('worker object is null - exiting worker thread')
        return
    end
    worker.running = true
    worker.stopThread = false
    loop
      if worker.StopThread 
        break
      end
      sleep(1000)
      worker.doTask()
    end
    worker.running = false

  INCLUDE('CCIWORKR.INC')


cciWorkerClass.DoTask                      procedure
    code
    beep

cciWorkerClass.Start                       procedure
    code
    if ~self.running
       start(WorkerThread,,address(self))
    end

cciWorkerClass.Stop                        procedure
    code
    self.StopThread = true

cciWorkerClass.Stopped                     procedure
    code
    return choose(self.running=0,true,false)


cciSafeWorkerClass.Construct        procedure
    code
    self.Start()

cciSafeWorkerClass.Destruct         procedure
    code
    self.Stop()
    loop
      if self.stopped() then break.
      yield
    end

